Codeforces Round 307 (Div. 2)
C
GukiZ hates Boxes
Codeforces
2200
原题
← BD →
翻译中…

Professor GukiZ is concerned about making his way to school, because massive piles of boxes are blocking his way.

翻译中…

In total there are $*n*$ piles of boxes, arranged in a line, from left to right, $*i*$-th pile ($1 ≤ *i* ≤ *n*$) containing $*a*_{*i*}$ boxes. Luckily, $*m*$ students are willing to help GukiZ by removing all the boxes from his way. Students are working simultaneously. At time $0$, all students are located left of the first pile. It takes one second for every student to move from this position to the first pile, and after that, every student must start performing sequence of two possible operations, each taking one second to complete. Possible operations are:

翻译中…
  1. If $*i* ≠ *n*$, move from pile $*i*$ to pile $*i* + 1$;
  2. If pile located at the position of student is not empty, remove one box from it.
翻译中…

GukiZ's students aren't smart at all, so they need you to tell them how to remove boxes before professor comes (he is very impatient man, and doesn't want to wait). They ask you to calculate minumum time $*t*$ in seconds for which they can remove all the boxes from GukiZ's way. Note that students can be positioned in any manner after $*t*$ seconds, but all the boxes must be removed.

翻译中…

Input

翻译中…

The first line contains two integers $*n*$ and $*m*$ ($1 ≤ *n*, *m* ≤ 10^{5}$), the number of piles of boxes and the number of GukiZ's students.

翻译中…

The second line contains $*n*$ integers $*a*_{1}, *a*_{2}, ... *a*_{*n*}$ ($0 ≤ *a*_{*i*} ≤ 10^{9}$) where $*a*_{*i*}$ represents the number of boxes on $*i*$-th pile. It's guaranteed that at least one pile of is non-empty.

翻译中…

Output

翻译中…

In a single line, print one number, minimum time needed to remove all the boxes in seconds.

翻译中…

Note

翻译中…

First sample: Student will first move to the first pile ($1$ second), then remove box from first pile ($1$ second), then move to the second pile ($1$ second) and finally remove the box from second pile ($1$ second).

翻译中…

Second sample: One of optimal solutions is to send one student to remove a box from the first pile and a box from the third pile, and send another student to remove a box from the third pile. Overall, $5$ seconds.

翻译中…

Third sample: With a lot of available students, send three of them to remove boxes from the first pile, four of them to remove boxes from the second pile, five of them to remove boxes from the third pile, and four of them to remove boxes from the fourth pile. Process will be over in $5$ seconds, when removing the boxes from the last pile is finished.

翻译中…

样例

Input #1
2 1
1 1
Output #1
4
InputCopy OutputCopy
Input #2
3 2
1 0 2
Output #2
5
InputCopy OutputCopy
Input #3
4 100
3 4 5 4
Output #3
5
InputCopy OutputCopy
题目信息
题号
551C
时间限制
2 s
内存限制
256 MB
标签
二分
贪心

题面与样例版权归 Codeforces 及出题人所有;中文翻译由 AI 生成(CI 管线),如有出入请以原文为准。